﻿// BenLincoln.TheLostWorlds.CDHashes
// Copyright 2018 Ben Lincoln
// https://www.thelostworlds.net/
//

// This file is part of BenLincoln.TheLostWorlds.CDHashes.

// BenLincoln.TheLostWorlds.CDHashes is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.TheLostWorlds.CDHashes is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.TheLostWorlds.CDHashes (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/* Hashing algorithm used in all versions of Legacy of Kain: Defiance */

namespace BenLincoln.TheLostWorlds.CDHashes
{
    public class DefianceHash : CDHash
    {
        public DefianceHash()
            : base()
        {
        }

        public override byte[] GetHashBytes(string input, bool hashRawText)
        {
            string inVal = input;

            char[] inChars, tempChars;
            uint a0, a1, a2, a3, v0, v1, t0, t1, t2;
            uint nameHash;
            inChars = inVal.ToLower().ToCharArray();
            a0 = 0;
            a2 = 0xFFFFFFFF;
            v0 = 0;
            v1 = (uint)inChars.GetUpperBound(0);
            a1 = v1;

            t0 = 0x04C11DB7;
            t1 = 0x80000000;
            t2 = 0xFFFFFFFF;

            nameHash = 0;

            foreach (char currentChar in inChars)
            {
                v0 = (uint)currentChar;
                a1 = v1 - 1;
                a0++;
                //a3 = 7;

                v0 = v0 << 24;
                a2 = a2 ^ v0;
                for (int i = 0; i < 8; i++)
                {
                    v1 = a2 & t1;
                    v0 = a2 << 1;
                    a2 = v0 ^ t0;
                    if (v1 == 0)
                    {
                        a2 = v0;
                    }
                }
                v1 = a1;
            }

            nameHash = ~a2;

            return UIntToByteArray(nameHash);
        }
    }
}
